import org.graphstream.algorithm.Dijkstra;
import org.graphstream.algorithm.generator.Generator;
import org.graphstream.algorithm.generator.RandomGenerator;
import org.graphstream.graph.Edge;
import org.graphstream.graph.Graph;
import org.graphstream.graph.Node;
import org.graphstream.graph.implementations.SingleGraph;

import java.util.ArrayList;
import java.util.Iterator;

import static org.graphstream.algorithm.Dijkstra.Element.EDGE;

public class Djikstra {

    private int v;

    public Graph generer_Aleatoire(int taille) {
        v = taille;

        Graph graph = new SingleGraph("Graphe aléatoire");
        System.setProperty("org.graphstream.ui.renderer", "org.graphstream.ui.j2dviewer.J2DGraphRenderer");
        graph.addAttribute("ui.quality");
        graph.addAttribute("ui.antialias");
        Generator g = new RandomGenerator();
        g.addSink(graph);
        g.begin();

        for (int i = 0; i < taille; i++)
            g.nextEvents();
        g.end();
        return graph;
    }



    //METHODE DJIKSTRA DU COURS
    public void djikstraCours(Graph graph, String poids, Node source){
        ArrayList<Node> noeuds = new ArrayList<>();



        
        int[] dist = new int[v];
        for (int i = 0; i < v; i++)
            dist[i] = Integer.MAX_VALUE;

        noeuds.add(source);


        for(Node n : noeuds){
            Iterator<Node> it = n.getNeighborNodeIterator();

        }

    }
    public static void djikstraPCC(Graph graph, Node sommet1, Node sommet2) {

        Dijkstra dijkstra = new Dijkstra(EDGE, "result", "length");

        dijkstra.init(graph);
        dijkstra.setSource(graph.getNode(String.valueOf(sommet1)));
        dijkstra.compute();
        //System.out.println(dijkstra.getPath(graph.getNode(String.valueOf(sommet2))));

        System.out.printf("%s->%s:%6.2f%n", dijkstra.getSource(), sommet2, dijkstra.getPathLength(sommet2));
        for (Edge edge : dijkstra.getPathEdges(sommet2)) edge.addAttribute("ui.style", "fill-color: red;");

    }
}
